/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SshTrait type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SshTrait{}

// SshTrait struct for SshTrait
type SshTrait struct {
	UseSSH        *bool          `json:"useSSH,omitempty"`
	CertificateId NullableString `json:"certificateId,omitempty"`
	SshHost       NullableString `json:"sshHost,omitempty"`
	SshPort       NullableInt32  `json:"sshPort,omitempty"`
	SshRemoteHost NullableString `json:"sshRemoteHost,omitempty"`
	SshRemotePort NullableInt32  `json:"sshRemotePort,omitempty"`
	SshUsername   NullableString `json:"sshUsername,omitempty"`
	SshPassword   NullableString `json:"sshPassword,omitempty"`
}

// NewSshTrait instantiates a new SshTrait object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSshTrait() *SshTrait {
	this := SshTrait{}
	return &this
}

// NewSshTraitWithDefaults instantiates a new SshTrait object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSshTraitWithDefaults() *SshTrait {
	this := SshTrait{}
	return &this
}

// GetUseSSH returns the UseSSH field value if set, zero value otherwise.
func (o *SshTrait) GetUseSSH() bool {
	if o == nil || IsNil(o.UseSSH) {
		var ret bool
		return ret
	}
	return *o.UseSSH
}

// GetUseSSHOk returns a tuple with the UseSSH field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SshTrait) GetUseSSHOk() (*bool, bool) {
	if o == nil || IsNil(o.UseSSH) {
		return nil, false
	}
	return o.UseSSH, true
}

// HasUseSSH returns a boolean if a field has been set.
func (o *SshTrait) HasUseSSH() bool {
	if o != nil && !IsNil(o.UseSSH) {
		return true
	}

	return false
}

// SetUseSSH gets a reference to the given bool and assigns it to the UseSSH field.
func (o *SshTrait) SetUseSSH(v bool) {
	o.UseSSH = &v
}

// GetCertificateId returns the CertificateId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *SshTrait) GetCertificateId() string {
	if o == nil || IsNil(o.CertificateId.Get()) {
		var ret string
		return ret
	}
	return *o.CertificateId.Get()
}

// GetCertificateIdOk returns a tuple with the CertificateId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *SshTrait) GetCertificateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.CertificateId.Get(), o.CertificateId.IsSet()
}

// HasCertificateId returns a boolean if a field has been set.
func (o *SshTrait) HasCertificateId() bool {
	if o != nil && o.CertificateId.IsSet() {
		return true
	}

	return false
}

// SetCertificateId gets a reference to the given NullableString and assigns it to the CertificateId field.
func (o *SshTrait) SetCertificateId(v string) {
	o.CertificateId.Set(&v)
}

// SetCertificateIdNil sets the value for CertificateId to be an explicit nil
func (o *SshTrait) SetCertificateIdNil() {
	o.CertificateId.Set(nil)
}

// UnsetCertificateId ensures that no value is present for CertificateId, not even an explicit nil
func (o *SshTrait) UnsetCertificateId() {
	o.CertificateId.Unset()
}

// GetSshHost returns the SshHost field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *SshTrait) GetSshHost() string {
	if o == nil || IsNil(o.SshHost.Get()) {
		var ret string
		return ret
	}
	return *o.SshHost.Get()
}

// GetSshHostOk returns a tuple with the SshHost field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *SshTrait) GetSshHostOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.SshHost.Get(), o.SshHost.IsSet()
}

// HasSshHost returns a boolean if a field has been set.
func (o *SshTrait) HasSshHost() bool {
	if o != nil && o.SshHost.IsSet() {
		return true
	}

	return false
}

// SetSshHost gets a reference to the given NullableString and assigns it to the SshHost field.
func (o *SshTrait) SetSshHost(v string) {
	o.SshHost.Set(&v)
}

// SetSshHostNil sets the value for SshHost to be an explicit nil
func (o *SshTrait) SetSshHostNil() {
	o.SshHost.Set(nil)
}

// UnsetSshHost ensures that no value is present for SshHost, not even an explicit nil
func (o *SshTrait) UnsetSshHost() {
	o.SshHost.Unset()
}

// GetSshPort returns the SshPort field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *SshTrait) GetSshPort() int32 {
	if o == nil || IsNil(o.SshPort.Get()) {
		var ret int32
		return ret
	}
	return *o.SshPort.Get()
}

// GetSshPortOk returns a tuple with the SshPort field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *SshTrait) GetSshPortOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.SshPort.Get(), o.SshPort.IsSet()
}

// HasSshPort returns a boolean if a field has been set.
func (o *SshTrait) HasSshPort() bool {
	if o != nil && o.SshPort.IsSet() {
		return true
	}

	return false
}

// SetSshPort gets a reference to the given NullableInt32 and assigns it to the SshPort field.
func (o *SshTrait) SetSshPort(v int32) {
	o.SshPort.Set(&v)
}

// SetSshPortNil sets the value for SshPort to be an explicit nil
func (o *SshTrait) SetSshPortNil() {
	o.SshPort.Set(nil)
}

// UnsetSshPort ensures that no value is present for SshPort, not even an explicit nil
func (o *SshTrait) UnsetSshPort() {
	o.SshPort.Unset()
}

// GetSshRemoteHost returns the SshRemoteHost field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *SshTrait) GetSshRemoteHost() string {
	if o == nil || IsNil(o.SshRemoteHost.Get()) {
		var ret string
		return ret
	}
	return *o.SshRemoteHost.Get()
}

// GetSshRemoteHostOk returns a tuple with the SshRemoteHost field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *SshTrait) GetSshRemoteHostOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.SshRemoteHost.Get(), o.SshRemoteHost.IsSet()
}

// HasSshRemoteHost returns a boolean if a field has been set.
func (o *SshTrait) HasSshRemoteHost() bool {
	if o != nil && o.SshRemoteHost.IsSet() {
		return true
	}

	return false
}

// SetSshRemoteHost gets a reference to the given NullableString and assigns it to the SshRemoteHost field.
func (o *SshTrait) SetSshRemoteHost(v string) {
	o.SshRemoteHost.Set(&v)
}

// SetSshRemoteHostNil sets the value for SshRemoteHost to be an explicit nil
func (o *SshTrait) SetSshRemoteHostNil() {
	o.SshRemoteHost.Set(nil)
}

// UnsetSshRemoteHost ensures that no value is present for SshRemoteHost, not even an explicit nil
func (o *SshTrait) UnsetSshRemoteHost() {
	o.SshRemoteHost.Unset()
}

// GetSshRemotePort returns the SshRemotePort field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *SshTrait) GetSshRemotePort() int32 {
	if o == nil || IsNil(o.SshRemotePort.Get()) {
		var ret int32
		return ret
	}
	return *o.SshRemotePort.Get()
}

// GetSshRemotePortOk returns a tuple with the SshRemotePort field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *SshTrait) GetSshRemotePortOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.SshRemotePort.Get(), o.SshRemotePort.IsSet()
}

// HasSshRemotePort returns a boolean if a field has been set.
func (o *SshTrait) HasSshRemotePort() bool {
	if o != nil && o.SshRemotePort.IsSet() {
		return true
	}

	return false
}

// SetSshRemotePort gets a reference to the given NullableInt32 and assigns it to the SshRemotePort field.
func (o *SshTrait) SetSshRemotePort(v int32) {
	o.SshRemotePort.Set(&v)
}

// SetSshRemotePortNil sets the value for SshRemotePort to be an explicit nil
func (o *SshTrait) SetSshRemotePortNil() {
	o.SshRemotePort.Set(nil)
}

// UnsetSshRemotePort ensures that no value is present for SshRemotePort, not even an explicit nil
func (o *SshTrait) UnsetSshRemotePort() {
	o.SshRemotePort.Unset()
}

// GetSshUsername returns the SshUsername field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *SshTrait) GetSshUsername() string {
	if o == nil || IsNil(o.SshUsername.Get()) {
		var ret string
		return ret
	}
	return *o.SshUsername.Get()
}

// GetSshUsernameOk returns a tuple with the SshUsername field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *SshTrait) GetSshUsernameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.SshUsername.Get(), o.SshUsername.IsSet()
}

// HasSshUsername returns a boolean if a field has been set.
func (o *SshTrait) HasSshUsername() bool {
	if o != nil && o.SshUsername.IsSet() {
		return true
	}

	return false
}

// SetSshUsername gets a reference to the given NullableString and assigns it to the SshUsername field.
func (o *SshTrait) SetSshUsername(v string) {
	o.SshUsername.Set(&v)
}

// SetSshUsernameNil sets the value for SshUsername to be an explicit nil
func (o *SshTrait) SetSshUsernameNil() {
	o.SshUsername.Set(nil)
}

// UnsetSshUsername ensures that no value is present for SshUsername, not even an explicit nil
func (o *SshTrait) UnsetSshUsername() {
	o.SshUsername.Unset()
}

// GetSshPassword returns the SshPassword field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *SshTrait) GetSshPassword() string {
	if o == nil || IsNil(o.SshPassword.Get()) {
		var ret string
		return ret
	}
	return *o.SshPassword.Get()
}

// GetSshPasswordOk returns a tuple with the SshPassword field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *SshTrait) GetSshPasswordOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.SshPassword.Get(), o.SshPassword.IsSet()
}

// HasSshPassword returns a boolean if a field has been set.
func (o *SshTrait) HasSshPassword() bool {
	if o != nil && o.SshPassword.IsSet() {
		return true
	}

	return false
}

// SetSshPassword gets a reference to the given NullableString and assigns it to the SshPassword field.
func (o *SshTrait) SetSshPassword(v string) {
	o.SshPassword.Set(&v)
}

// SetSshPasswordNil sets the value for SshPassword to be an explicit nil
func (o *SshTrait) SetSshPasswordNil() {
	o.SshPassword.Set(nil)
}

// UnsetSshPassword ensures that no value is present for SshPassword, not even an explicit nil
func (o *SshTrait) UnsetSshPassword() {
	o.SshPassword.Unset()
}

func (o SshTrait) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SshTrait) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.UseSSH) {
		toSerialize["useSSH"] = o.UseSSH
	}
	if o.CertificateId.IsSet() {
		toSerialize["certificateId"] = o.CertificateId.Get()
	}
	if o.SshHost.IsSet() {
		toSerialize["sshHost"] = o.SshHost.Get()
	}
	if o.SshPort.IsSet() {
		toSerialize["sshPort"] = o.SshPort.Get()
	}
	if o.SshRemoteHost.IsSet() {
		toSerialize["sshRemoteHost"] = o.SshRemoteHost.Get()
	}
	if o.SshRemotePort.IsSet() {
		toSerialize["sshRemotePort"] = o.SshRemotePort.Get()
	}
	if o.SshUsername.IsSet() {
		toSerialize["sshUsername"] = o.SshUsername.Get()
	}
	if o.SshPassword.IsSet() {
		toSerialize["sshPassword"] = o.SshPassword.Get()
	}
	return toSerialize, nil
}

type NullableSshTrait struct {
	value *SshTrait
	isSet bool
}

func (v NullableSshTrait) Get() *SshTrait {
	return v.value
}

func (v *NullableSshTrait) Set(val *SshTrait) {
	v.value = val
	v.isSet = true
}

func (v NullableSshTrait) IsSet() bool {
	return v.isSet
}

func (v *NullableSshTrait) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSshTrait(val *SshTrait) *NullableSshTrait {
	return &NullableSshTrait{value: val, isSet: true}
}

func (v NullableSshTrait) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSshTrait) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
